# -*- coding: cp1252 -*-
import urllib,urllib2,re,xbmc,xbmcplugin,xbmcgui,xbmcaddon,sys,os,cookielib,htmlentitydefs,urlresolver,requests
from BeautifulSoup import BeautifulSoup, SoupStrainer
from t0mm0.common.addon import Addon
from t0mm0.common.net import Net
from metahandler import metahandlers



##
# Bunkford - 2013 - 2016.
#
# TODO:
#    TONS
helpText = """
For this script to work correctly you need to have valid login information for the following invite only sites:

     http://www.iseri.es
     http://www.bunnymovie.com
     http://www.bunnyseries.com
     
     Add your login credentials to the plugin settings.

Downloading:

     For downloading to work correctly you need to specify download paths in the plugin settings.
"""
def xbmcpath(path,filename):
     translatedpath = os.path.join(xbmc.translatePath( path ), ''+filename+'')
     return translatedpath

#CONSTANTS
_PLUG = Addon('plugin.video.bunkford', sys.argv)

USER_AGENT = "Mozilla/5.0 (iPhone; U; CPU iPhone OS 4_0 like Mac OS X; en-us) AppleWebKit/532.9 (KHTML, like Gecko) Version/4.0.5 Mobile/8A293 Safari/6531.22.7"


#bunnymovie:  constants
bunny_URL = 'http://www.bunnymovie.com'
bunny_LOGIN_URL = 'http://bunnymovie.com/wp-login.php'

#bunnyseries: constraints
bunnyseries_URL = 'http://www.bunnyseries.com'
bunnyseries_LOGIN_URL = 'http://bunnyseries.com/wp-login.php'

adatapath = 'special://profile/addon_data/plugin.video.bunkford'
metapath = adatapath+'/mirror_page_meta_cache'
downinfopath = adatapath+'/downloadinfologs'
transdowninfopath = xbmcpath(downinfopath,'')
transmetapath = xbmcpath(metapath,'')
translateddatapath = xbmcpath(adatapath,'')
path = adatapath
datapath = _PLUG.get_profile()
artdir = "special://home/addons/plugin.video.bunkford/resources/media/"
downloadScript = "special://home/addons/plugin.video.bunkford/resources/lib/download.py"
textBoxesScript = "special://home/addons/plugin.video.bunkford/resources/lib/textBoxes.py"

#cookie constants
cookie_path = os.path.join(datapath)
cookiejar = os.path.join(cookie_path,'losmovies.lwp')
net = Net()


# FUNCTIONS USED   

def f7(seq):
    #sorts list
    seen = set()
    seen_add = seen.add
    return [ x for x in seq if x not in seen and not seen_add(x)]

def trim():
    #gets list of good links to trim non working
    goodlinks = []
    req = urllib2.Request(allurl)
    req.add_header('User-Agent', USER_AGENT)
    response = urllib2.urlopen(req)
    for link in BeautifulSoup(response.read(), parseOnlyThese=SoupStrainer('a', attrs={'class':'lc'})):
        goodlinks.append(link['href'])
    return goodlinks

def unescape(text):
##
# Removes HTML or XML character references and entities from a text string.
#
# @param text The HTML (or XML) source text.
# @return The plain text, as a Unicode string, if necessary.
    def fixup(m):
        text = m.group(0)
        if text[:2] == "&#":
            # character reference
            try:
                if text[:3] == "&#x":
                    return unichr(int(text[3:-1], 16))
                else:
                    return unichr(int(text[2:-1]))
            except ValueError:
                pass
        else:
            # named entity
            try:
                text = unichr(htmlentitydefs.name2codepoint[text[1:-1]])
            except KeyError:
                pass
        return text # leave as is
    return re.sub("&#?\w+;", fixup, text)

def Search(string,url):
     net.set_cookies(cookiejar)
     searchurl = url
     searchstring = string
     form = {"s" : searchstring}
     html = net.http_POST(searchurl, form, headers={'User-Agent':USER_AGENT}).content
     return html

def SearchTV(string,url):
     net.set_cookies(cookiejar)
     searchurl = url
     searchstring = string
     form = {"s" : searchstring}
     html = net.http_POST(searchurl, form, {'User-Agent':USER_AGENT}).content
     return html

def SearchMovie(string,url):
     net.set_cookies(cookiejar)
     searchurl = url
     searchstring = string
     form = {"s" : searchstring}
     html = net.http_POST(searchurl, form).content
     return html

def cleanUnicode(string):
    try:
        string = string.replace("'","").replace(unicode(u'\u201c'), '"').replace(unicode(u'\u201d'), '"').replace(unicode(u'\u2019'),'').replace(unicode(u'\u2026'),'...').replace(unicode(u'\u2018'),'').replace(unicode(u'\u2013'),'-')
        return string
    except:
        return string


#START MAIN SCRIPT
def STARTPOINT():
        if _PLUG.get_setting('bunny-username') is not '':
             addDir('MOVIES (http://bunnymovie.com)',bunny_URL,300,artdir+'movie.png')
        if _PLUG.get_setting('bunnyseries-username') is not '':
             addDir('TV (http://bunnyseries.com)',bunnyseries_URL,200,artdir+'series.png')
             
        if _PLUG.get_setting('bunnyseries-username') is '':
             if _PLUG.get_setting('bunny-username') is '':
                    xbmc.executebuiltin("Notification(Need to login!, Plese set up login information.)")
                    xbmc.executebuiltin("Addon.OpenSettings(plugin.video.bunkford)")
       
#BUNNYSERIES.COM
def bunnyseries_LoginStartup():
      if _PLUG.get_setting('bunnyseries-username') == '':
           xbmc.executebuiltin("Notification(Need to login!, Please visit http://bunnyseries.com and sign up.)")
                     
      loginurl = bunnyseries_LOGIN_URL
      login = _PLUG.get_setting('bunnyseries-username')
      password = _PLUG.get_setting('bunnyseries-password')
      form = {'log' : login, 'pwd' : password}
      net.http_POST(loginurl, form,{'User-Agent':USER_AGENT})
      net.save_cookies(cookiejar)
      
def BUNNYSERIESMAIN():
     bunnyseries_LoginStartup()

     #Name,URL,MODE,Image
     addDir('List',bunnyseries_URL,211,artdir+'tvshows-logo.png')
     addDir('Recent',bunnyseries_URL,212,artdir+'tvrecent-logo.png')
     addDir('Search',bunnyseries_URL,315,artdir+'tvsearch-logo.png')

#211     
def BUNNYSERIESSHOWLIST():
        net.set_cookies(cookiejar)
        req = urllib2.Request(url)
        req.add_header('User-Agent',USER_AGENT)
        response = urllib2.urlopen(req)
        soup = BeautifulSoup(response.read())
        data = soup.findAll('div',attrs={'class':'tab-section cat-tag categories wptouch-menu'});
        for div in data:
             links = div.findAll('a')
             for a in links:
                  name = a['href'][29:-1].capitalize()
                  name = unescape(name)
                  name = name.replace('-', ' ');
                  addDir(name,a['href'],212,artdir+'genre.png')

#212
def BUNNYSERIESLIST(url,name):
        net.set_cookies(cookiejar)
        origname = name;
        req = urllib2.Request(url)
        req.add_header('User-Agent',USER_AGENT)
        response = urllib2.urlopen(req)
        soup = BeautifulSoup(response.read())
        data = soup.findAll('div',attrs={'class':'box clearfix show-thumbnails'});
        for div in data:
            link = div.find('a')['href']
            image = div.find('img')['src']
            name = div.find('h2').find('a').contents[0]                
            name = unescape(name);
            name = cleanUnicode(name);

            meta = None
            #getMeta(name=None,season=None,episode=None,year=None,imdbid=None,tvdbid=None):
            try:
                 showname = name.split('-', 1)[0]
                 s = name.split('-', 1)[1].upper().split('E',1)[0].replace('S','')
                 e = name.split('-', 1)[1].upper().split('E',1)[1].replace('E','')
                 meta = getMeta(name=showname,season=s, episode=e) 
            except:
                 pass
            meta['season'] = s
            meta['episod'] = e        
            addDir(name,link,313,image,meta=meta)
            
        #LOAD MORE MOVIES
        try:
             next_post = soup.find('a',attrs={'class':'load-more-link no-ajax'})['rel'];
             if next_post != "#":
                  addDir('Next Page',next_post,212,artdir+'next.png') #adds dir listing for next page
        except:
             pass
     
#BUNNYMOVIE.COM
def bunny_LoginStartup():
      if _PLUG.get_setting('bunny-username') == '':
           xbmc.executebuiltin("Notification(Need to login!, Please visit http://bunnymovie.com and sign up.)")
                     
      loginurl = bunny_LOGIN_URL
      login = _PLUG.get_setting('bunny-username')
      password = _PLUG.get_setting('bunny-password')
      form = {'log' : login, 'pwd' : password}
      net.http_POST(loginurl, form,{'User-Agent':USER_AGENT})
      net.save_cookies(cookiejar)
        
def BUNNYMAIN():
     bunny_LoginStartup()

     #Name,URL,MODE,Image
     addDir('Genres',bunny_URL,311,artdir+'moviegenre-logo.png')
     addDir('Recent',bunny_URL,312,artdir+'movierecent-logo.png')
     addDir('Search',bunny_URL,320,artdir+'moviesearch-logo.png')

#311
def BUNNYGENRE():
        net.set_cookies(cookiejar)
        req = urllib2.Request(url)
        req.add_header('User-Agent',USER_AGENT)
        response = urllib2.urlopen(req)
        soup = BeautifulSoup(response.read())
        data = soup.findAll('div',attrs={'id':'section-slider'});
        for div in data:
             links = div.findAll('a')
             for a in links:
                  name = a['href'][28:-1].capitalize()
                  name = unescape(name)
                  addDir(name,a['href'],312,artdir+'genre.png')

#312
def BUNNYGENRELIST(url,name):
        net.set_cookies(cookiejar)
        req = urllib2.Request(url)
        req.add_header('User-Agent',USER_AGENT)
        response = urllib2.urlopen(req)
        soup = BeautifulSoup(response.read())
        data = soup.findAll('div',attrs={'class':'entry'});
        for div in data:
            link = div.find('a')['href']
            image = div.find('img')['src']
            name = div.find('h2').contents[0]
            name = unescape(name);
            name = cleanUnicode(name);
            name = re.sub('[^a-zA-Z0-9-_*.\-\)\( ]', '', name)

            meta = None
            #getMeta(name=None,season=None,episode=None,year=None,imdbid=None,tvdbid=None):
            try:
                 showname = name.split('(',1)[0][:-1]
                 year = name.split('(',1)[1][:-2]
                 meta = getMeta(name=showname,year=year) 
            except:
                 pass
               
            addDir(name,link,313,image,meta=meta)
            
        #LOAD MORE MOVIES
        try:
             next_post = soup.find('a',attrs={'class':'load-more-link no-ajax'})['rel'];
             if next_post != "#":
                  addDir(next_post,next_post,'312',artdir+'next.png') #adds dir listing for next page
        except:
             pass
#313
def BUNNYMOVIE(url,name):
        net.set_cookies(cookiejar)
        req = urllib2.Request(url)
        req.add_header('User-Agent',USER_AGENT)
        response = urllib2.urlopen(req)
        soup = BeautifulSoup(response.read()) 
        data = soup.findAll("a", attrs={'class':'playButton'});
        for a in data:
             link = a['href']
             link = link.replace('https://element.lv/go?url=','');
                       
        # new GF.TO garbage.. need to resolve link again
        net.set_cookies(cookiejar)
        req = urllib2.Request(link)
        req.add_header('User-Agent',USER_AGENT)
        response = urllib2.urlopen(req)
        link = response.read()
        response.close()
        match=re.compile('window.location="(.+?)";').findall(link)
        for url in match:
             link = unescape(url)

        meta = None
        trailer = False
        try:
             showname = name.split('-', 1)[0]
             s = name.split('-', 1)[1].upper().split('E',1)[0].replace('S','')
             e = name.split('-', 1)[1].upper().split('E',1)[1].replace('E','')
             meta = getMeta(name=showname,season=s, episode=e) 
        except:
             try:
                  showname = name.split('(',1)[0][:-1]
                  year = name.split('(',1)[1][:-2]
                  meta = getMeta(name=showname,year=year)

                  preview = soup.findAll('div',attrs={'class':'video-container'});
                  for div in preview:
                       trailer = div.find('iframe')['src']
                       sources = []
                       hosted_media = urlresolver.HostedMediaFile(url=trailer)
                       sources.append(hosted_media)
                       source = urlresolver.choose_source(sources)
                       trailer = source.resolve()
             except:
                  pass
             
        #image = soup.find('img',attrs={'class':re.compile(r"aligncenter.+?")})['src'];
        image = "";
        
        #plot = soup.findAll('div',attrs={'class':re.compile(r"post.+?section.+?")});
     
        #for div in plot:
        #     synopsis = div.findAll('p')
        #     synopsis = synopsis[2].nextSibling
        #     synopsis = unescape(synopsis)
        synopsis = "";
        
        infoLabels = {}
        infoLabels={ "Title": name }
        infoLabels={ "Plot": synopsis }
        #infoLabels={ "Trailer": trailer } Makes Plot disapear for some reason
               
        addLink(name,link,image,'movie',infoLabels=infoLabels,trailer=trailer,meta=meta) #adds link of episode

#216
def SEARCHNEXTPAGE(url):
        net.set_cookies(cookiejar)
        req = urllib2.Request(url)
        req.add_header('User-Agent',USER_AGENT)
        response = urllib2.urlopen(req)
        soup = BeautifulSoup(response.read())
        div = soup.find('div',attrs={'id':'post-results'});
        li = div.findAll('li');  
        for l in li:
            link = l.find('a')['href']
            image = l.find('img')['src']
            name = l.find('a').contents[0]
            name = unescape(name);
            name = cleanUnicode(name); 

            meta = None
            #getMeta(name=None,season=None,episode=None,year=None,imdbid=None,tvdbid=None):
            try:
                showname = name.split('-', 1)[0]
                s = name.split('-', 1)[1].upper().split('E',1)[0].replace('S','')
                e = name.split('-', 1)[1].upper().split('E',1)[1].replace('E','')
               
                meta = getMeta(name=showname,season=s, episode=e) 

            except:
                 pass
          
            addDir(name,link,313,image,meta=meta)

        #LOAD MORE 
        try:
             next_post = soup.find('a',attrs={'class':'load-more-post-link no-ajax'})['rel'];
             addDir('Next Page',next_post,216,artdir+'next.png') #adds dir listing for next page
        except:
             pass

#316
def SEARCHNEXTPAGEMOVIE(url):
        net.set_cookies(cookiejar)
        req = urllib2.Request(url)
        req.add_header('User-Agent',USER_AGENT)
        response = urllib2.urlopen(req)
        soup = BeautifulSoup(response.read())
        li = soup.findAll('div',attrs={'class':'entry'});
        for l in li:
            link = l.find('a')['href']
            image = l.find('img')['src']
            name = l.find('h2').contents[0]
            name = unescape(name);
            name = cleanUnicode(name);
            name = re.sub('[^a-zA-Z0-9-_*.\-\)\( ]', '', name)
       

            meta = None
            #getMeta(name=None,season=None,episode=None,year=None,imdbid=None,tvdbid=None):
            try:
                 showname = name.split('(',1)[0][:-1]
                 year = name.split('(',1)[1][:-2]
                 meta = getMeta(name=showname,year=year) 
            except:
                 pass
               
            addDir(name,link,313,image,meta=meta)

        #LOAD MORE 
        try:
             next_post = soup.find('a',attrs={'class':'load-more-post-link no-ajax'})['rel'];
             addDir('Next Page',next_post,216,artdir+'next.png') #adds dir listing for next page
        except:
             pass
          
#320          
def SEARCHSITEMOVIE(url):
        keyboard = xbmc.Keyboard()

        keyboard.setHeading('Enter a search term')
        keyboard.doModal()
        if keyboard.isConfirmed():
            search_string = keyboard.getText()

            link = SearchTV(search_string,url)
            soup = BeautifulSoup(link)

            li = soup.findAll('div',attrs={'class':'entry'});  
            for l in li:
                link = l.find('a')['href']
                image = l.find('img')['src']
                name = l.find('h2').contents[0]
                name = unescape(name);
                name = cleanUnicode(name);
                name = re.sub('[^a-zA-Z0-9-_*.\-\)\( ]', '', name)
            

                meta = None
                #getMeta(name=None,season=None,episode=None,year=None,imdbid=None,tvdbid=None):
                try:
                     showname = name.split('(',1)[0][:-1]
                     year = name.split('(',1)[1][:-2]
                     meta = getMeta(name=showname,year=year) 
                except:
                     pass
                    
                addDir(name,link,313,image,meta=meta)

            #LOAD MORE 
            try:
                 next_post = soup.find('a',attrs={'class':'load-more-post-link no-ajax'})['rel'];
                 if next_post != "#":
                      s = search_string.replace(' ','+')
                      addDir('Next Page',next_post+'?s='+s+'&submit',316,artdir+'next.png') #adds dir listing for next page
            except:
                 pass

                               
#315
def SEARCHSITE(url):
        keyboard = xbmc.Keyboard()

        keyboard.setHeading('Enter a search term')
        keyboard.doModal()
        if keyboard.isConfirmed():
            search_string = keyboard.getText()

            link = SearchTV(search_string,url)
            soup = BeautifulSoup(link)

            div = soup.find('div',attrs={'id':'post-results'});
            li = div.findAll('li');  
            for l in li:
                link = l.find('a')['href']
                image = l.find('img')['src']
                name = l.find('a').contents[0]
                name = unescape(name);
                name = cleanUnicode(name);

                meta = None
                #getMeta(name=None,season=None,episode=None,year=None,imdbid=None,tvdbid=None):
                try:
                    showname = name.split('-', 1)[0]
                    s = name.split('-', 1)[1].upper().split('E',1)[0].replace('S','')
                    e = name.split('-', 1)[1].upper().split('E',1)[1].replace('E','')
                    
                    meta = getMeta(name=showname,season=s, episode=e) 

                except:
                     pass
               
                addDir(name,link,313,image,meta=meta)

            #LOAD MORE 
            try:
                 next_post = soup.find('a',attrs={'class':'load-more-post-link no-ajax'})['rel'];
                 if next_post != "#":
                      s = search_string.replace(' ','+')
                      addDir('Next Page',next_post+'?s='+s+'&submit',216,artdir+'next.png') #adds dir listing for next page
            except:
                 pass

                           
def get_params():
        param=[]
        paramstring=sys.argv[2]
        if len(paramstring)>=2:
                params=sys.argv[2]
                cleanedparams=params.replace('?','')
                if (params[len(params)-1]=='/'):
                        params=params[0:len(params)-2]
                pairsofparams=cleanedparams.split('&')
                param={}
                for i in range(len(pairsofparams)):
                        splitparams={}
                        splitparams=pairsofparams[i].split('=')
                        if (len(splitparams))==2:
                                param[splitparams[0]]=splitparams[1]
                                
        return param

 
def addLink(name,url,iconimage,mediaType=None,infoLabels=False,trailer=None,meta=None):
        ok=True

        downloadPath = _PLUG.get_setting(mediaType+'downpath')
                
        #handle adding context menus
        contextMenuItems = []
        contextMenuItems.append(('Show Information', 'XBMC.Action(Info)',))
        contextMenuItems.append(('Download Video', "RunScript("+downloadScript+","+url.encode('utf-8','ignore')+","+downloadPath+","+name+","+mediaType+")",))
        if trailer is not False:
             contextMenuItems.append(('Watch Trailer', 'xbmc.PlayMedia('+trailer+')',))

        if meta is None:     
             liz=xbmcgui.ListItem(name, iconImage="DefaultVideo.png", thumbnailImage=iconimage)
             liz.setProperty('fanart_image', 'special://home/addons/plugin.video.bunkford/fanart.jpg')
        else:
             liz = xbmcgui.ListItem(name, iconImage=str(meta['cover_url']), thumbnailImage=str(meta['cover_url']))


             liz.setInfo('video', infoLabels=meta)
             liz.setProperty('fanart_image', meta['backdrop_url'])
             
             infoLabels = {}
             infoLabels['title'] = name
             infoLabels['plot'] = cleanUnicode(meta['plot']) # to-check if we need cleanUnicode
             infoLabels['duration'] = str(meta['duration'])
             infoLabels['premiered'] = str(meta['premiered'])
             infoLabels['mpaa'] = str(meta['mpaa'])
             infoLabels['code'] = str(meta['imdb_id'])
             infoLabels['rating'] = float(meta['rating'])
             #infoLabels['overlay'] = meta['watched'] # watched 7, unwatched 6

             if meta.has_key('season_num'):
                 infoLabels['Episode'] = int(meta['episode_num'])
                 infoLabels['Season'] =int(meta['season_num'])
             
        liz.setInfo( type="Video", infoLabels=infoLabels )

        if contextMenuItems:
             liz.addContextMenuItems(contextMenuItems, replaceItems=True)
             
        ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=url,listitem=liz)
        return ok
     
def getMeta(name=None,season=None,episode=None,year=None,imdbid=None,tvdbid=None):
        print 'getMeta() ran',name,season,episode,year,imdbid,tvdbid
        useMeta = _PLUG.get_setting('use-meta')
        print useMeta
        if useMeta == 'true':
             print 'use-meta = true'
             metaget=metahandlers.MetaData(translateddatapath)
             if episode and season is not None:
                  print 'getMeta() is tvshow'
                  #get_episode_meta(self, tvshowtitle, imdb_id, season, episode, air_date='', episode_title='', overlay=''):
                  #get season and episode
                  meta=metaget.get_meta('tvshow', name,'')
                  #emeta = metaget.get_episode_meta(name,meta['imdb_id'],season,episode)
                  
                  #_get_tv_extra(self, meta):
                  #meta=metaget._get_tv_extra(meta)
             else:
                  print 'getMeta() is movie'
                  #get_meta(self, media_type, name, imdb_id='', tmdb_id='', year='', overlay=6):
                  #get regular
                  meta=metaget.get_meta('movie',name,year=year)
        return meta
     
def addDir(name,url,mode,iconimage,meta=None,season=None):

        
        #handle adding context menus
        contextMenuItems = []
        contextMenuItems.append(('Help', "RunScript("+textBoxesScript+",HELP,"+helpText+")",))

        
        u=sys.argv[0]+"?url="+urllib.quote_plus(url.encode('utf-8','ignore'))+"&mode="+str(mode)+"&name="+urllib.quote_plus(name.encode('utf-8','ignore'))+ "&season="+str(season)+"&iconimage="+str(iconimage)
        ok=True
        
        if meta is None:     
             liz=xbmcgui.ListItem(name, iconImage="DefaultFolder.png", thumbnailImage=iconimage)
             liz.setProperty('fanart_image', 'special://home/addons/plugin.video.bunkford/fanart.jpg')
        else:
             contextMenuItems.append(('Show Information', 'XBMC.Action(Info)',))
             liz = xbmcgui.ListItem(name, iconImage=str(meta['cover_url']), thumbnailImage=str(meta['cover_url']))


             liz.setInfo('video', infoLabels=meta)
             liz.setProperty('fanart_image', meta['backdrop_url'])

                
             infoLabels = {}
             infoLabels['title'] = name
             infoLabels['plot'] = cleanUnicode(meta['plot']) # to-check if we need cleanUnicode
             infoLabels['duration'] = str(meta['duration'])
             infoLabels['premiered'] = str(meta['premiered'])
             infoLabels['mpaa'] = str(meta['mpaa'])
             infoLabels['code'] = str(meta['imdb_id'])
             infoLabels['rating'] = float(meta['rating'])
             #infoLabels['overlay'] = meta['watched'] # watched 7, unwatched 6

             if meta.has_key('season_num'):
                 infoLabels['Episode'] = int(meta['episode_num'])
                 infoLabels['Season'] =int(meta['season_num'])
                 print 'No refresh for episodes yet'
                 
        liz.setInfo( type="Video", infoLabels={ "Title": name } )

        if contextMenuItems:
             liz.addContextMenuItems(contextMenuItems, replaceItems=False)
             
        ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=liz,isFolder=True)
        return ok
        
#for passing parameters between menus              
params=get_params()
iconimage=None
season=None
url=None
name=None
mode=None

try:
        iconimage=urllib.unquote_plus(params["iconimage"])
except:
        pass
try:
        season=urllib.unquote_plus(params["season"])
except:
        pass
try:
        url=urllib.unquote_plus(params["url"])
except:
        pass
try:
        name=urllib.unquote_plus(params["name"])
except:
        pass
try:
        mode=int(params["mode"])
except:
        pass

print "Mode: "+str(mode)
print "URL: "+str(url)
print "Name: "+str(name)
print "Season: "+str(season)
print "Iconimage: "+str(iconimage)

#main exicution of menu navigation
if mode==None or url==None or len(url)<1:
        print ""
        STARTPOINT()
        
elif mode==200:
        print""
        BUNNYSERIESMAIN()

elif mode==211:
        print""
        BUNNYSERIESSHOWLIST()

elif mode==212:
        print""
        BUNNYSERIESLIST(url,name)

elif mode==213:
        print""
        BUNNYMOVIE(url,name)

elif mode==215:
        print""
        SEARCHSITE(url)
        
elif mode==216:
        print""
        SEARCHNEXTPAGE(url)
        
elif mode==300:
        print""
        BUNNYMAIN()
        
elif mode==311:
        print""
        BUNNYGENRE()

elif mode==312:
        print""
        BUNNYGENRELIST(url,name)

elif mode==313:
        print""
        BUNNYMOVIE(url,name)

elif mode==315:
        print""
        SEARCHSITE(url)

elif mode==316:
        print""
        SEARCHNEXTPAGEMOVIE(url)
        
elif mode==320:
        print""
        SEARCHSITEMOVIE(url)

xbmcplugin.endOfDirectory(int(sys.argv[1]))
